// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"
	"time"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/definition"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/term"
)

// Definition is the model entity for the Definition schema.
type Definition struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// CreatedAt holds the value of the "created_at" field.
	CreatedAt time.Time `json:"created_at,omitempty"`
	// UpdatedAt holds the value of the "updated_at" field.
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// Text holds the value of the "text" field.
	Text string `json:"text,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the DefinitionQuery when eager-loading is set.
	Edges            DefinitionEdges `json:"edges"`
	term_definitions *int
	selectValues     sql.SelectValues
}

// DefinitionEdges holds the relations/edges for other nodes in the graph.
type DefinitionEdges struct {
	// Term holds the value of the term edge.
	Term *Term `json:"term,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [1]bool
}

// TermOrErr returns the Term value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e DefinitionEdges) TermOrErr() (*Term, error) {
	if e.loadedTypes[0] {
		if e.Term == nil {
			// Edge was loaded but was not found.
			return nil, &NotFoundError{label: term.Label}
		}
		return e.Term, nil
	}
	return nil, &NotLoadedError{edge: "term"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Definition) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case definition.FieldID:
			values[i] = new(sql.NullInt64)
		case definition.FieldText:
			values[i] = new(sql.NullString)
		case definition.FieldCreatedAt, definition.FieldUpdatedAt:
			values[i] = new(sql.NullTime)
		case definition.ForeignKeys[0]: // term_definitions
			values[i] = new(sql.NullInt64)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Definition fields.
func (d *Definition) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case definition.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			d.ID = int(value.Int64)
		case definition.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				d.CreatedAt = value.Time
			}
		case definition.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				d.UpdatedAt = value.Time
			}
		case definition.FieldText:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field text", values[i])
			} else if value.Valid {
				d.Text = value.String
			}
		case definition.ForeignKeys[0]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field term_definitions", value)
			} else if value.Valid {
				d.term_definitions = new(int)
				*d.term_definitions = int(value.Int64)
			}
		default:
			d.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the Definition.
// This includes values selected through modifiers, order, etc.
func (d *Definition) Value(name string) (ent.Value, error) {
	return d.selectValues.Get(name)
}

// QueryTerm queries the "term" edge of the Definition entity.
func (d *Definition) QueryTerm() *TermQuery {
	return NewDefinitionClient(d.config).QueryTerm(d)
}

// Update returns a builder for updating this Definition.
// Note that you need to call Definition.Unwrap() before calling this method if this Definition
// was returned from a transaction, and the transaction was committed or rolled back.
func (d *Definition) Update() *DefinitionUpdateOne {
	return NewDefinitionClient(d.config).UpdateOne(d)
}

// Unwrap unwraps the Definition entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (d *Definition) Unwrap() *Definition {
	_tx, ok := d.config.driver.(*txDriver)
	if !ok {
		panic("ent: Definition is not a transactional entity")
	}
	d.config.driver = _tx.drv
	return d
}

// String implements the fmt.Stringer.
func (d *Definition) String() string {
	var builder strings.Builder
	builder.WriteString("Definition(")
	builder.WriteString(fmt.Sprintf("id=%v, ", d.ID))
	builder.WriteString("created_at=")
	builder.WriteString(d.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(d.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("text=")
	builder.WriteString(d.Text)
	builder.WriteByte(')')
	return builder.String()
}

// Definitions is a parsable slice of Definition.
type Definitions []*Definition
